/*
 * Test.java
 *
 * Created on 21 maj 2007, 15:57
 */

package eu.bojar.hibernatetest.web;

import java.io.IOException;
import java.io.PrintWriter;

import javax.ejb.EJB;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import eu.bojar.hibernatetest.model.Message;
import eu.bojar.hibernatetest.service.MessageFacadeLocal;

/**
 * 
 * @author Jarek
 * @version
 */
public class TestGetReference extends HttpServlet {

	@EJB
	private MessageFacadeLocal messageFacade;

	/**
	 * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
	 * methods.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void processRequest(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html;charset=UTF-8");
		PrintWriter out = response.getWriter();

		/* TODO output your page here */
		out.println("<html>");
		out.println("<head>");
		out.println("<title>Servlet Test</title>");
		out.println("</head>");
		out.println("<body>");
		out.println("<h1>Find - this should throw an exception</h1>");
		try {
			test(request, response, out);
		} catch (Exception e) {
			out.println("<pre>");
			out.println(e.toString());
			e.printStackTrace(out);
			out.println("</pre>");
		}

		out.println("</body>");
		out.println("</html>");
		out.close();
	}

	protected void test(HttpServletRequest request,
			HttpServletResponse response, PrintWriter out) {

		Message message = messageFacade.getReference(2);

		out.println("<pre>");
		out.println("message.id " + message.getId());
		out.println("message.subject " + message.getSubject());
		out.println("message.previous.subject "
				+ message.getPrevious().getSubject());
		out.println("</pre>");

	}

	// <editor-fold defaultstate="collapsed" desc=
	// "HttpServlet methods. Click on the + sign on the left to edit the code.">
	/**
	 * Handles the HTTP <code>GET</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * Handles the HTTP <code>POST</code> method.
	 * 
	 * @param request
	 *            servlet request
	 * @param response
	 *            servlet response
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}

	/**
	 * Returns a short description of the servlet.
	 */
	public String getServletInfo() {
		return "Short description";
	}
	// </editor-fold>
}
